import string,cgi,time
from os import curdir, sep
from BaseHTTPServer import BaseHTTPRequestHandler, HTTPServer

from classes import *       #Contient la definition de la classe Joueur
from gestion_main import *  #Les fonctions de comparaison de main
from constante import *     #Les constantes AS, DAME...
from distribution import *  #Les fonctions de distribution
from server_config import * #Configuration du serveur (argent initial etc.)

# -- Initialisation du jeu --#
jeu = [(i,j) for i in xrange(2,15) for j in xrange(4)]
random.shuffle(jeu)

# -- Initialisation des variables globales -- #
joueur_liste = [Joueur((i+1)*1000, "Joueur"+str(i+1)) for i in xrange(3)]
cartes_milieu = []
joueur_courant = 0
code = {"0": 0, "1": 1, "2": 2} #, "3": 3}
tour = 0
pot = 0
mise_min = BIG_BLIND
dealer = 0
n = len(joueur_liste)
last = 1
gagnants = []
participant = n
nb_tapis = 0
b="tite blind"
B="Big blind"
D="Dealer"
doit_calculer = True
fin = False




# --  Bug Fix -- #

def is_blind (j):
    if joueur_liste[j].position == b:
        return 0
    elif joueur_liste[j].position == B:
        return 1
    else:
        return -1


# -- Clef aleatoire, 16 chiffres -- #
def alea():
    i = "%d%d%d%d" % (random.randint(1000,9999), random.randint(1000,9999), random.randint(1000,9999), random.randint(1000,9999))
    if (i in code):
        return alea()
    else:
        return i

def print_gagnant(j):
    if j.gagnant:
        return '<img src="/couronne.gif" alt="Gagnant" title="Gagnant :)"/>'
    else:
        return ''

def print_pos(pos):
    if pos==D:
        return '<img src="/dealer.gif" alt="Dealer" title="Dealer"/>'
    elif pos==b:
        return '<img src="/little_blind.gif" alt="Ch\'tite Blind" title="Ch\'tite Blind"/>'
    elif pos==B:
        return '<img src="/big_blind.gif" alt="Big Blind" title="Big Blind"/>'
    else:
        return ''


# -- Recuperer la semantique de l'URL -- #
def url_parser(s):
    l = s.split("/")
    try:
        while True:
            l.remove("")
    except:
        pass
    return(l)

# -- Joueur suivant (ignore si joueur couche) -- #
def joueur_suivant(jc):
    js = (jc+1) % n
    if participant == 0 or participant-nb_tapis == 0:
        return 0
    else:
        if joueur_liste[js].couche or joueur_liste[js].pot <> 0:
            return(joueur_suivant(js))
        else:
            return(js)

# -- Fonction pratique pour envoyer un fichier en HTTP -- #
def envoie_fichier(fichier, client):
    f = open(curdir + sep + fichier)
    client.wfile.write(f.read())
    f.close()

# -- Classe de gestion des requetes -- #
class MyHandler(BaseHTTPRequestHandler):
    
    def do_GET(self):
        global tour, code, joueur_courant, pot, mise_min, dealer, n, jeu, cartes_milieu, last, gagnants, participant, doit_calculer, fin, nb_tapis

        l = url_parser(self.path)
        try:
            joueur = l[0] #Code du joueur, on retrouve le joueur par : code[joueur]
            command = l[1]
        except:
            joueur = ""
            command = ""
            
        j = code.setdefault(joueur, "-")
        
        if command=="jeu_choix":
            if l[2] == "r": #demande une recharge
                if fin:
                    self.wfile.write("<br /><div><table style='margin:auto'><tr><th>Joueurs</th><th>Main</th><th>Type</th><th>Gagnants</th></tr>")
                    for a,k in gagnants:
                        m, t, ind, l2 = k.meilleure_main
                        self.wfile.write("<tr><td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>" % (k.nom, html_main(m), t, print_gagnant(k)))
                    self.wfile.write("</table></div>")
                    
                if tour <= 4:
                    self.wfile.write("Pot : %d<br />Mise minimale: %d<br />Tour : %d<br />" % (pot, mise_min, tour))    
                    self.wfile.write("<hr />")
                    self.wfile.write("</div>")
                    self.wfile.write("<table style='align:center;margin:auto;'><tr><td><div  style='border:solid 3px orange'><table>")
                    self.wfile.write("<tr><th>Position</th><th>Nom</th><th>Argent</th><th>Derniere action</th></tr>")
                    for (num,k) in enumerate(joueur_liste):
                        self.wfile.write("<tr>")
                        if (num <> joueur_courant or tour == 0) and k.last_action<>-2:
                            self.wfile.write("<td>%s</td><td>%s</td><td>%d $</td><td>%s</td>" % (print_pos(k.position), k.nom, k.argent, k.last_action))
                        elif (num <> joueur_courant or tour == 0):
                            self.wfile.write("<td>%s</td><td>%s</td><td>%d $</td><td>%s</td>" % (print_pos(k.position), k.nom, k.argent, ''))                    
                        else:
                            self.wfile.write("<td>%s</td><td>%s</td><td>%d $</td><td>%s</td>" % (print_pos(k.position), k.nom, k.argent, "En train de jouer"))
                        self.wfile.write("</tr>")
                    self.wfile.write("</table><br />")
                    self.wfile.write(html_main(joueur_liste[j].main))
                    self.wfile.write("<br />")
                    if tour == 0:
                        envoie_fichier("/pages/demarre.html", self)
                    elif j == joueur_courant:
    #-- Gestion des couches --#                        
                        envoie_fichier("/pages/menu.html", self)


                    elif joueur_liste[j].couche:
                        self.wfile.write("Vous etes couch&eacute;<br /><br />")
                    else:
                        self.wfile.write("Attendez votre tour!<br /><br />")
                    envoie_fichier("/pages/deco.html", self)  
                    self.wfile.write("</div></td>")
                    
                    self.wfile.write("<td>")
                    self.wfile.write("<br /><div style='background-image:url(\"poker-table.png\"); width:400px; height:250px; margin:auto; padding-top:150px'>")
                    self.wfile.write(html_main(cartes_milieu))
                    self.wfile.write("</div></td></tr></table><br />")
                

            elif l[2] == "q": #demande la derniere mise a jour
                self.wfile.write(last)
                
        elif self.path.endswith(".gif") or self.path.endswith(".png"):
            s = url_parser(self.path)[-1]
            envoie_fichier("images/" + s, self)
        elif self.path.endswith(".js")  or self.path.endswith(".css"):
            s = url_parser(self.path)[-1]
            envoie_fichier("pages/" + s, self)
        else:
            # -- Affichage du debut de page (toujours le meme) -- #
            self.send_response(200)
            self.end_headers()
            
            envoie_fichier("/pages/tete.html", self)

            # -- Page d'accueil -- #
            if self.path == "/":
                envoie_fichier("/pages/welcome.html", self)
            # -- Page de jeu -- #
            elif n>0:
                try:
                    if command=="jeu":
                        envoie_fichier("/pages/script.html", self)

                                                            
                    elif command=="suivre":
                        if j == joueur_courant and (tour<>0):
                            x = mise_min-joueur_liste[j].last_mise
                            joueur_liste[j].mise(x)
                            joueur_liste[j].a_mise = True
                            joueur_liste[j].last_action = "Suit"
                            pot += x
                            joueur_courant = joueur_suivant(joueur_courant)
                            joueur_liste[j].last_mise = mise_min
                            
                            for k in joueur_liste:
                                if k.pot <> 0 and not(k.fin_pot):
                                    k.pot += mise_min
                                    k.last_action = "Tapis. Gains max %d" % k.pot
                            
                            self.wfile.write("<script>document.location = 'jeu'</script>")
                            last += 1

                        else:
                            self.wfile.write("Tsss... Arrete de tricher !")
                            
                    elif command=="relance":
                        relance = int(l[2])
                        if relance>0 and j == joueur_courant and (tour <> 0):
                            joueur_liste[j].a_mise = True
                            x = mise_min-joueur_liste[j].last_mise+relance
                            joueur_liste[j].mise(x)
                            joueur_liste[j].last_action = "Relance de %d" % relance
                            mise_min = x
                            pot += mise_min
                            joueur_liste[j].last_mise = x
                            joueur_courant = joueur_suivant(joueur_courant)
                            last += 1
                            
                            for k in joueur_liste:
                                if k.pot <> 0 and not(k.fin_pot):
                                    k.pot += mise_min
                                    k.last_action = "Tapis. Gains max %d" % k.potin_pot
                                    k.fin_pot = True
                            
                            self.wfile.write("<script>document.location = '../jeu'</script>")
                        else:
                            self.wfile.write("Tsss... Arrete de tricher !")

                    elif command=="Check":
                        if j == joueur_courant and (tour <> 0):
                            if mise_min == 0 or joueur_liste[j].last_mise == mise_min:
                                joueur_liste[j].last_mise = mise_min
                                joueur_liste[j].a_mise = True
                                joueur_liste[j].last_action = "Check"
                                joueur_courant = joueur_suivant(joueur_courant)
                                last += 1
                                self.wfile.write("<script>document.location = 'jeu'</script>")
                            else:
                                self.wfile.write("<script>alert('Vous ne pouvez pas checker'); document.location = 'jeu'</script>")
                        else:
                            self.wfile.write("Tsss... Arrete de tricher !")
                    elif command=="coucher":
                        if j == joueur_courant and (tour <> 0):
                            print joueur_liste[j].nom
                            joueur_liste[j].couche = True
                            joueur_liste[j].last_action = "Se couche"
                            participant -= 1
                            joueur_courant = joueur_suivant(joueur_courant)
                            last += 1
                            
                            self.wfile.write("<script>document.location = 'jeu'</script>")
                        else:
                            self.wfile.write("Tsss... Arrete de tricher !")
                    elif command=="tapis":
                        if j == joueur_courant and (tour <> 0):
                        
                            for k in joueur_liste:
                                if k.pot <> 0 and not(k.fin_pot):
                                    k.pot += joueur_liste[j].argent
                                    k.last_action = "Tapis. Gains max %d" % k.pot
                        
                            x = joueur_liste[j].argent
                            mise_min = max(x, mise_min)
                            pot += x
                            joueur_liste[j].last_action = "Tapis. Gain max : %d" % pot
                            joueur_liste[j].mise(x)
                            joueur_liste[j].last_mise = x
                            joueur_liste[j].pot = pot
                            nb_tapis += 1
                            joueur_courant = joueur_suivant(joueur_courant)
                            
                            last += 1
                            self.wfile.write("<script>document.location = 'jeu'</script>")
                        else:
                            self.wfile.write("Tsss... Arrete de tricher !")
                except ValueError, s:
                    self.wfile.write("<script>alert('Vous n\\\'avez pas assez d\\\'argent pour faire cela.'); document.location = '/%s/jeu'</script>" % joueur) 
                    
                # -- Passe-t-on au tour suivant ? -- #

                
                suiv = True
                if doit_calculer:
                    for j in joueur_liste:
                        if not(j.couche) and j.pot == 0:
                            suiv = suiv and (j.last_mise == mise_min) and (j.a_mise == True)
                    if participant == 1 or nb_tapis-participant == 0:
                        for i in xrange(tour+1, 5):
                            distribution(i, cartes_milieu, jeu, joueur_liste)
                        tour = 5
                        suiv = True
                    if suiv:
                        if tour < 4:
                            tour += 1
                            mise_min = 0
                            joueur_courant = (dealer+1) % n
                            if joueur_liste[joueur_courant].couche:
                                joueur_courant = joueur_suivant(joueur_courant)
                            distribution(tour, cartes_milieu, jeu, joueur_liste)
                            for j in joueur_liste:
                                j.last_mise = 0
                                j.a_mise = False
                                j.fin_pot = True
                                if not(j.couche) and j.pot == 0:
                                    j.last_action = ""
                        else:
                            tour = 0
                            fin = True
                            doit_calculer = False
                            for j in joueur_liste:
                                j.meilleure_main = meilleure_main(j.main+cartes_milieu) 
                            
                            gagnants = gagnant(joueur_liste) #liste des gagnants
                            
                            u = 0
                            while u < len(gagnants): #on enleve les joueurs couches, pas de for, le del merde
                                (a, j) = gagnants[u]
                                if j.couche:
                                    del gagnants[u]
                                else:
                                    u += 1
                            ng = 0        
                            (a0, j0) = gagnants[0]
                            for (a, j) in gagnants: #On cherche les egalites
                                if tri_joueur(j0, j) == 0:
                                    j.gagnant = True
                                    ng += 1

                            for (a, j) in gagnants: #distribution des gains
                                if j.gagnant:
                                    if joueur_liste[a].pot <> 0:
                                        joueur_liste[a].argent += min(joueur_liste[a].pot, pot/ng)
                                    else:
                                        joueur_liste[a].argent += pot/ng
                                        
                            u = 0
                            while u < len(joueur_liste):
                                if joueur_liste[u].deco <> "":
                                    del code[joueur_liste[u].deco]
                                    del joueur_liste[u]
                                    for k in code.keys():
                                        try:
                                            if code[k] > u:
                                                code[k] = code[k]-1
                                        except:
                                            pass
                                    n -= 1
                                else:
                                    u = u+1
                            
            # -- Pages inexistante ou n'ayant aucun sens encore -- #
            else:
                self.wfile.write("Tu sors...")             
                
            # -- Affichage du pied de page (toujours le meme) -- #
            envoie_fichier("/pages/pied.html", self)


    def do_POST(self):
        global tour, code, joueur_courant, pot, mise_min, dealer, n, jeu, cartes_milieu, last, participant, fin, doit_calculer, nb_tapis

        # -- Toujours le joli en-tete -- #
        envoie_fichier("/pages/tete.html", self)
        
        # -- On recupere les champs de la requete POST -- #
        form = cgi.FieldStorage(fp=self.rfile, headers=self.headers, environ={'REQUEST_METHOD':'POST', 'CONTENT_TYPE':self.headers['Content-Type']})
        l = url_parser(self.path)
        try:
            joueur = l[0] #Code du joueur, on retrouve le joueur par : code[joueur]
            command = l[1]
        except:
            joueur = ""
            command = ""

        # -- Un joueur veut rejoindre la partie -- #
        if self.path == "/join":
            if tour==0:
                if n < MAX_JOUEUR:
                    s = form["nom"].value
                    joueur_liste.append(Joueur(400, s))
                    n += 1
                    self.wfile.write("Welcome "+s)
                    codej = alea()
                    code[codej] = n-1 #Ici un code aleatoire
                    self.wfile.write("<script>document.location = '%s/jeu'</script>" % codej)
                    last += 1
                else:
                    self.wfile.write("Serveur complet")
            else:
                self.wfile.write("Une partie est en cours. Veuillez attendre la fin pour rejoindre.")

        elif command == "/welcome.html":
            self.wfile.write("<script>document.location = 'welcome'</script>")
                
        # -- Un joueur veut demarrer la partie -- #
        elif command == "demarre":
            if n < 2:
                self.wfile.write("Il n'y a pas assez de joueurs.")
            elif tour <> 0:
                self.wfile.write("Une partie est deja en cours !<br /><a href='jeu'>Jouer</a>")
            else:
                tour = 1
                participant = 0
                for j in joueur_liste:
                    if j.argent > 0:
                        participant += 1
                
                nb_tapis = 0
                dealer = (dealer+1) % n
                mise_min = BIG_BLIND                            
                jeu = [(i,j) for i in xrange(2,15) for j in xrange(4)]
                random.shuffle(jeu)
                cartes_milieu = []
                participant = n
                fin = False
                doit_calculer = True
                for k in joueur_liste:
                    k.couche = False
                    k.pot = 0
                    k.last_action = ""
                    k.last_mise = 0
                    k.a_mise = False
                    k.main = []
                    k.meilleure_main = []
                    k.position = ''
                    k.fin_pot = False
                    
                distribution(tour, cartes_milieu, jeu, joueur_liste)
                pot = 0
                nb_tapis = 0
                
                if joueur_liste[(dealer+1) % n].argent >= SMALL_BLIND:
                    joueur_liste[(dealer+1) % n].mise(SMALL_BLIND)
                else:
                    joueur_liste[(dealer+1) % n].couche = True
                    joueur_liste[(dealer+1) % n].last_action = "Pas assez pour payer la Small Blind. Elimin&eacute;."
                    joueur_liste[(dealer+1) % n].deco = joueur
                    participant -= 1
                    last += 1
                    
                if joueur_liste[(dealer+2) % n].argent >= BIG_BLIND:
                    joueur_liste[(dealer+2) % n].mise(BIG_BLIND)
                else:
                    print "aaa"
                    joueur_liste[(dealer+2) % n].couche = True
                    joueur_liste[(dealer+2) % n].deco = joueur
                    joueur_liste[(dealer+2) % n].last_action = "Pas assez pour payer la Big Blind. Elimin&eacute;."
                    participant -= 1
                    last += 1
                    
                joueur_liste[dealer].position = D
                joueur_liste[(dealer+1) % n].position= b
                joueur_liste[(dealer+2) % n].position= B  

                pot += BIG_BLIND + SMALL_BLIND
                joueur_courant = joueur_suivant((dealer+2) % n)
                last += 1
                self.wfile.write("<script>document.location = 'jeu'</script>")

        elif command == "deco":
            if tour == 0 or tour == 5:
                j = code.setdefault(joueur, "Fuck u")
                del joueur_liste[j]
                del code[joueur]
                for k in code.keys():
                    try:
                        if code[k] > j:
                            code[k] = code[k]-1
                    except:
                        pass
                n -= 1
                last += 1
            else:
                j = code.setdefault(joueur, "Fuck u")
                joueur_liste[j].couche = True
                joueur_liste[j].deco = joueur
                joueur_liste[j].last_action = "Quitte le jeu"
                last += 1
                participant -= 1
                if joueur_courant == j:
                    joueur_courant = joueur_suivant(joueur_courant)
            self.wfile.write("Au revoir !")
        else:
            self.wfile.write("Tu sors...")
            
        # -- Toujours le joli pied -- #    
        envoie_fichier("/pages/pied.html", self)


def main():
    try:
        server = HTTPServer(('', 8000), MyHandler)
        print 'Start'
        server.serve_forever()
    except KeyboardInterrupt:
        print 'Shutting down'
        server.socket.close()

if __name__ == '__main__':
    main()

